package net.minecraftforge.common;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import net.minecraft.util.WeightedRandom;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.gen.structure.MapGenVillage;
import net.minecraft.world.biome.WorldChunkManager;

public class BiomeManager
{
    public static List<BiomeEntry> desertBiomes = new ArrayList<BiomeEntry>();
    public static List<BiomeEntry> warmBiomes = new ArrayList<BiomeEntry>();
    public static List<BiomeEntry> coolBiomes = new ArrayList<BiomeEntry>();
    public static List<BiomeEntry> icyBiomes = new ArrayList<BiomeEntry>();
    
    public static List<BiomeGenBase> oceanBiomes = new ArrayList<BiomeGenBase>();
    
    public static ArrayList<BiomeGenBase> strongHoldBiomes = new ArrayList<BiomeGenBase>();
    public static ArrayList<BiomeGenBase> strongHoldBiomesBlackList = new ArrayList<BiomeGenBase>();

    static
    {
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_76767_f, 10));
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_150585_R, 10));
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_76770_e, 10));
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_76772_c, 10));
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_150583_P, 10));
        warmBiomes.add(new BiomeEntry(BiomeGenBase.field_76780_h, 10));

        coolBiomes.add(new BiomeEntry(BiomeGenBase.field_76767_f, 10));
        coolBiomes.add(new BiomeEntry(BiomeGenBase.field_76770_e, 10));
        coolBiomes.add(new BiomeEntry(BiomeGenBase.field_76768_g, 10));
        coolBiomes.add(new BiomeEntry(BiomeGenBase.field_76772_c, 10));

        icyBiomes.add(new BiomeEntry(BiomeGenBase.field_76774_n, 30));
        icyBiomes.add(new BiomeEntry(BiomeGenBase.field_150584_S, 10));

        oceanBiomes.add(BiomeGenBase.field_76771_b);
        oceanBiomes.add(BiomeGenBase.field_150575_M);
        oceanBiomes.add(BiomeGenBase.field_76776_l);
    }

    @SuppressWarnings("unchecked")
    public static void addVillageBiome(BiomeGenBase biome, boolean canSpawn)
    {
        if (!MapGenVillage.field_75055_e.contains(biome))
        {
            ArrayList<BiomeGenBase> biomes = new ArrayList<BiomeGenBase>(MapGenVillage.field_75055_e);
            biomes.add(biome);
            MapGenVillage.field_75055_e = biomes;
        }
    }

    @SuppressWarnings("unchecked")
    public static void removeVillageBiome(BiomeGenBase biome)
    {
        if (MapGenVillage.field_75055_e.contains(biome))
        {
            ArrayList<BiomeGenBase> biomes = new ArrayList<BiomeGenBase>(MapGenVillage.field_75055_e);
            biomes.remove(biome);
            MapGenVillage.field_75055_e = biomes;
        }
    }

    public static void addStrongholdBiome(BiomeGenBase biome)
    {
        if (!strongHoldBiomes.contains(biome))
        {
            strongHoldBiomes.add(biome);
        }
    }

    public static void removeStrongholdBiome(BiomeGenBase biome)
    {
        if (!strongHoldBiomesBlackList.contains(biome))
        {
            strongHoldBiomesBlackList.add(biome);
        }
    }

    public static void addSpawnBiome(BiomeGenBase biome)
    {
        if (!WorldChunkManager.allowedBiomes.contains(biome))
        {
            WorldChunkManager.allowedBiomes.add(biome);
        }
    }

    public static void removeSpawnBiome(BiomeGenBase biome)
    {
        if (WorldChunkManager.allowedBiomes.contains(biome))
        {
            WorldChunkManager.allowedBiomes.remove(biome);
        }
    }
    
    public static class BiomeEntry extends WeightedRandom.Item
    {
        public final BiomeGenBase biome;
        
        public BiomeEntry(BiomeGenBase biome, int weight)
        {
            super(weight);
            
            this.biome = biome;
        }
    }
}